unit FormMain;

{*****************************************************************}
{                                                                 }
{  FormMain                                                       }
{                                                                 }
{  Main form of UnitUsage                                         }
{                                                                 }
{  Contains GUI related stuff and - sad to say - parts of the     }
{  code analysis.                                                 }
{                                                                 }
{  (c) 2007, 2008 M. Braun                                        }
{  Contact: info@grizzlymotion.com                                }
{                                                                 }
{*****************************************************************}



interface

{$WARN UNIT_PLATFORM OFF}


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StrUtils, StdCtrls, Buttons, ExtCtrls, CheckLst, ComCtrls,
  IniFiles, MMSystem, FileCtrl, ClipBrd,
  Exec, DelDirective, DotGlob, ExtDlgs, JPEG, Printers, Form_about, FormOptions,
  FViewer, XPMan;




TYPE
  THistory     = packed RECORD
                   H_InUse       : boolean;
                   H_Reverse     : boolean;
                   H_DisplayUnit : shortstring;
                   H_State       : ARRAY OF TCheckBoxState;
                 END;
  TPTHistory   = ^THistory;

CONST
  Msg_ShowDOT  = wm_user + 1717;

CONST
  CMaxHistory  = 31;
  Msg_LoadFile = wm_User + 310;

{ TNode is  }
type TNode = class(TObject)
  public
    DotID   :  integer;
  end;

{ TNodeList is a descendant of TList that is designed to hold TNodes.  }
type TNodeList = class(TList)
 public
    procedure clear;  override;
    procedure AddNode(_DotID: integer{; _recDepth:  integer});
 end;

type
  TForm_Main = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Openproject1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel2: TPanel;
    CheckListBox_Units: TCheckListBox;
    StatusBar1: TStatusBar;
    Panel_Right: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    SaveDialog_Project: TSaveDialog;
    OpenDialog_Project: TOpenDialog;
    Saveproject1: TMenuItem;
    Saveprojectas1: TMenuItem;
    Project1: TMenuItem;
    Edit1: TMenuItem;
    Selectall1: TMenuItem;
    Unselectall1: TMenuItem;
    Selectunitswithsourceonly1: TMenuItem;
    N2: TMenuItem;
    Copygraph1: TMenuItem;
    Copybitmap1: TMenuItem;
    View1: TMenuItem;
    Autoscale1: TMenuItem;
    LoadSourcefile1: TMenuItem;
    Loadsettings1: TMenuItem;
    Loadcompilerdirectives1: TMenuItem;
    OpenDialog_ConfigFile: TOpenDialog;
    SavePictureDialog1: TSavePictureDialog;
    Help1: TMenuItem;
    Help2: TMenuItem;
    N3: TMenuItem;
    About1: TMenuItem;
    PrintDialog1: TPrintDialog;
    Memo_Watch: TMemo;
    Splitter_Horizontal: TSplitter;
    PopupMenu1: TPopupMenu;
    Includewithchilds1: TMenuItem;
    Includewithoutchilds1: TMenuItem;
    Hide1: TMenuItem;
    Splitter2: TSplitter;
    N4: TMenuItem;
    Newproject1: TMenuItem;
    Panel3: TPanel;
    Label_UnitOnDisplay: TLabel;
    SpeedButton_CopyToClipboard: TSpeedButton;
    SpeedButton_Save: TSpeedButton;
    SpeedButton_Print: TSpeedButton;
    SpeedButton_Home: TSpeedButton;
    SpeedButton_Previous: TSpeedButton;
    SpeedButton_Next: TSpeedButton;
    SpeedButton_TopDown: TSpeedButton;
    SpeedButton_BottomUp: TSpeedButton;
    Panel5: TPanel;
    Label4: TLabel;
    SpeedButton_SelectAll: TSpeedButton;
    SpeedButton_SelectNone: TSpeedButton;
    SpeedButton_SelectSource: TSpeedButton;
    Panel_ProjectSettings: TPanel;
    Label1: TLabel;
    SpeedButton_LoadMainSourceFile: TSpeedButton;
    SpeedButton_LoadDefines: TSpeedButton;
    Label2: TLabel;
    SpeedButton_Directives: TSpeedButton;
    Label3: TLabel;
    Label5: TLabel;
    Label_CompilerRelatedDirectives: TLabel;
    Edit_MainFileName: TEdit;
    Edit_Defines: TEdit;
    Edit_Directives: TEdit;
    ComboBox_Compiler: TComboBox;
    Panel6: TPanel;
    SpeedButton_OpenProject: TSpeedButton;
    SpeedButton_BuildGraph: TSpeedButton;
    SpeedButton_SaveProject: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton_Quit: TSpeedButton;
    Bevel1: TBevel;
    SpeedButton1: TSpeedButton;
    Bevel4: TBevel;
    Label6: TLabel;
    Edit_SearchPath: TEdit;
    SpeedButton_SearchPath: TSpeedButton;
    PopupMenu_ListOfUnits: TPopupMenu;
    Open1: TMenuItem;
    N5: TMenuItem;
    View2: TMenuItem;
    N6: TMenuItem;
    BuildTopDownTree1: TMenuItem;
    BuildBottomUptree1: TMenuItem;
    SpeedButton_ZoomIn: TSpeedButton;
    SpeedButton_ZoomOut: TSpeedButton;
    SpeedButton_ShowProjectData: TSpeedButton;
    SpeedButton_HideProjectData: TSpeedButton;
    Zoomin1: TMenuItem;
    Zoomout1: TMenuItem;
    N7: TMenuItem;
    Builddependencygraph1: TMenuItem;
    SpeedButton_AutoZoom: TSpeedButton;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N8: TMenuItem;
    Panel_NurHierWeilCheckboxKeinAlignHat: TPanel;
    CheckBox_AutoRefresh: TCheckBox;
    SpeedButton_Refresh: TSpeedButton;
    XPManifest1: TXPManifest;
    CheckBox_HighlightCircular: TCheckBox;
    DateTimePicker1: TDateTimePicker;
    CheckBox_HighlightNew: TCheckBox;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBox1Resize(Sender: TObject);
    procedure CheckListBox_UnitsDblClick(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1DblClick(Sender: TObject);
    procedure CheckListBox_UnitsClickCheck(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ScrollBox1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ScrollBox1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure FormResize(Sender: TObject);
    procedure SpeedButton_BuildGraphClick(Sender: TObject);
    procedure Edit_MainFileNameChange(Sender: TObject);
    procedure SpeedButton_SelectAllClick(Sender: TObject);
    procedure SpeedButton_SelectNoneClick(Sender: TObject);
    procedure SpeedButton_SelectSourceClick(Sender: TObject);
    procedure SpeedButton_TopDownClick(Sender: TObject);
    procedure SpeedButton_BottomUpClick(Sender: TObject);
    procedure SpeedButton_QuitClick(Sender: TObject);
    procedure SpeedButton_SaveProjectClick(Sender: TObject);
    procedure SpeedButton_OpenProjectClick(Sender: TObject);
    procedure Autoscale1Click(Sender: TObject);
    procedure SpeedButton_HomeClick(Sender: TObject);
    procedure SpeedButton_CopyToClipboardClick(Sender: TObject);
    procedure SpeedButton_LoadDefinesClick(Sender: TObject);
    procedure SpeedButton_DirectivesClick(Sender: TObject);
    procedure SpeedButton_SaveClick(Sender: TObject);
    procedure SpeedButton_LoadMainSourceFileClick(Sender: TObject);
    procedure Saveproject1Click(Sender: TObject);
    procedure SpeedButton_PrintClick(Sender: TObject);
    procedure SpeedButton_PreviousClick(Sender: TObject);
    procedure SpeedButton_NextClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure ComboBox_CompilerChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Edit_DefinesChange(Sender: TObject);
    procedure Edit_DirectivesChange(Sender: TObject);
    procedure ComboBox_RecursionChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Includewithchilds1Click(Sender: TObject);
    procedure Includewithoutchilds1Click(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CheckListBox_UnitsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckListBox_UnitsClick(Sender: TObject);
    procedure Newproject1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure SpeedButton_ShowProjectDataClick(Sender: TObject);
    procedure SpeedButton_HideProjectDataClick(Sender: TObject);
    procedure SpeedButton_SearchPathClick(Sender: TObject);
    procedure CheckListBox_UnitsMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Open1Click(Sender: TObject);
    procedure View2Click(Sender: TObject);
    procedure BuildTopDownTree1Click(Sender: TObject);
    procedure BuildBottomUptree1Click(Sender: TObject);
    procedure Zoomin1Click(Sender: TObject);
    procedure Zoomout1Click(Sender: TObject);
    procedure SpeedButton_ZoomInClick(Sender: TObject);
    procedure SpeedButton_ZoomOutClick(Sender: TObject);
    procedure SpeedButton_AutoZoomClick(Sender: TObject);
    procedure Copygraph1Click(Sender: TObject);
    procedure Copybitmap1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure CheckBox_AutoRefreshClick(Sender: TObject);
    procedure SpeedButton_RefreshClick(Sender: TObject);
    procedure CheckBox_HighlightCircularClick(Sender: TObject);
    procedure CheckBox_HighlightNewClick(Sender: TObject);
  private
                              // Explanation for Units, Uses1, Uses2, UsedBy1, UsedBy2:
                              // Units.strings contains the names of all units of the project.
                              // Uses1.string[i] contains all names of units that are referenced
                              //   by the unit Units.strings[i] in the USES clause in interface
                              // Uses2.string[i] contains all names of units that are referenced
                              //   by the unit Units.strings[i] in the USES clause in implementation
                              // UsedBy1.string[i] contains all names of units that are referencing
                              //   by the unit Units.strings[i] in their USES clause in interface
                              // UsedBy2.string[i] contains all names of units that are referencing
                              //   by the unit Units.strings[i] in their USES clause in interface
                              // Names within one string entry are seperated by a #1 character
    Units     : TStringList;  // List of unit names of the project
    Uses1     : TStringList;  // List of units used by other units (USES in interface)
    Uses2     : TStringList;  // List of units used by other units (USES in implementation)
    UsedBy1,                  // List of units that use a unit (USES in interface)
    UsedBy2   : TStringList;  // List of units that use a unit (USES in interface)
    Status    : TList;
    FileDate  : TList;
    NodeIndex : TNodeList;
    //NodeIndexExport: TNodeList;
    Defines,
    Settings,
    MainFile,
    SourcePath: string;
    Dot       : TDot;
    MouseOverUnit : string;
    DisplayUnit   : string;
    DefaultSwitch : string;
    DisplayHeight : integer;
    AutoScale,
    Reverse       : boolean;
    ProjectName   : string;
    PHistory      : ARRAY[0..CMaxHistory] OF TPTHistory;
    HistoryIndex  : integer;
    fProcessGraph : boolean;
    fBuildGraph   : boolean;
    fHighLightMU  : boolean;    // Highlight in "List of Units" the one under the mouse cursor
    BailOut       : boolean;
    HighlightIndex: integer;
    SearchPath    : string;
    RightClickIndex: integer;
    ParseErrorCnt : integer;
    MoveX0,
    MoveY0        : integer;
    LastDOTTick   : integer;
    StopDOT       : boolean;
    HighlightNew  : boolean;
    procedure AppOnMessage(var Msg: TMsg; var Handled: Boolean);
    procedure ActivateButtons;
    procedure ProcessFile(FileName: string);
    procedure BuildReverseTree;
    procedure Analyze(MainFile: string);
    procedure ShowGraph;
    procedure BuildGraphFromUnit(UnitName: string);
    FUNCTION  UnitInGraph(UnitName: string): boolean;
    FUNCTION  UnitShowChilds(UnitName: string): boolean;
    FUNCTION  UnitHasSource(UnitName: string): boolean;
    FUNCTION  UnitParseError(UnitName: string): boolean;
    FUNCTION  GetUnitIndex(UnitName: string): integer;
    PROCEDURE ReadDefAndSwitch(FN: string; VAR Defines, Switches: string);
    PROCEDURE SaveProject(const FileName: string);
    procedure OpenProjectEx(const FN: string);
    PROCEDURE OpenProject(const FileName: string);
    PROCEDURE HistoryClear;
    PROCEDURE HistoryBack;
    PROCEDURE HistoryForward;
    PROCEDURE HistoryAdd;
    PROCEDURE SaveStatus;
    PROCEDURE LoadStatus;
    PROCEDURE LoadProject(VAR Msg: TMessage); message Msg_LoadFile;
    procedure SelectUnitClick(Sender: TObject);
    procedure DisplaySource(FileName: string);
    procedure ZoomIn;
    procedure ZoomOut;
    procedure ExecuteWaitEvent(const ProcessInfo: TProcessInformation;
                               const StartedAt: integer;
                               var ATerminate: Boolean);
    procedure OnMsgShowDOT(VAR Msg: TMessage); message Msg_ShowDOT;
  public
    { Public declarations }
  end;

var
  Form_Main: TForm_Main;

implementation


{$R *.dfm}





CONST
  CHasSource   = $00000001;   // Source code of unit available
  CHasForm     = $00000002;   // Source code for a form (.dfm available)
  CParseError  = $00000004;   // Error while parsing that file. Treat as if it has no source code



{ TNodeList: List to collect the ID's for different Units. Added by MS.
  Purpose: Store additional information for each node (otherwise a TList would be sufficient)
           At the moment no other properties are stored.
}


{------------------------------------------------------------------------------}

procedure TNodeList.clear;
var
  i   : integer;
  node: TNode;
begin
  for i:= 1 to count do
  begin
     node:= self.Items[i-1];
     node.Free;
     node := nil;
  end;
  inherited clear;
end;

procedure TNodeList.AddNode(_DotID: integer{; _recDepth  :  integer});
var
  node: TNode;
begin
  node         := TNode.Create;
  node.DotID   := _DotID;
  //node.recDepth:= _recDepth;
  add(node);
end;


{--- TForm_Main (GUI event handlers etc.) -------------------------------------}


procedure TForm_Main.AppOnMessage(var Msg: TMsg; var Handled: Boolean);
begin
  IF Msg.Message = WM_KeyDown THEN
    BEGIN
      IF (Msg.wParam = VK_ADD) or (Msg.wParam = ord('+')) then
        begin
          Handled := true;
          ZoomIn;
        end;
      IF (Msg.wParam = VK_SUBTRACT) or (Msg.wParam = ord('-')) then
        begin
          Handled := true;
          ZoomOut;
        end;
    END;
end;


procedure TForm_Main.FormCreate(Sender: TObject);
VAR
  i :integer;
begin
  HighlightNew := false;
  Units      := TStringList.Create;
  Units.CaseSensitive := false;
  Uses1      := TStringList.Create;
  Uses2      := TStringList.Create;
  UsedBy1    := TStringList.Create;
  UsedBy2    := TStringList.Create;
  Status     := TList.Create;
  FileDate   := TList.Create;
  NodeIndex  := TNodeList.Create;
  Dot        := TDot.Create;
  DOT.MarkReversedArrow := true;
  DOT.ExecuteWaitEvent := ExecuteWaitEvent;
  ScrollBox1.DoubleBuffered := true;
  StatusBar1.Panels[0].Width := Panel2.Width + Panel_Right.BorderWidth;
  Reverse    := false;
  AutoScale  := true;
  ProjectName:= '';
  CheckListBox_Units.Hint := 'List of identified units.'#10 +
                             'Check unit to add it to graph'#10 +
                             'Grayed units will be added without childs';
  fProcessGraph := false;
  BailOut       := false;
  FOR i := 0 TO CMaxHistory DO
    New(PHistory[i]);
  HistoryClear;
  StopDOT := false;
  Application.OnMessage := AppOnMessage;
end;



procedure TForm_Main.Zoomin1Click(Sender: TObject);
begin
  ZoomIn;
end;


procedure TForm_Main.Zoomout1Click(Sender: TObject);
begin
  ZoomOut;
end;


procedure TForm_Main.SpeedButton_ZoomInClick(Sender: TObject);
begin
  ZoomIn;
end;


procedure TForm_Main.SpeedButton_ZoomOutClick(Sender: TObject);
begin
  ZoomOut;
end;


procedure TForm_Main.SpeedButton_AutoZoomClick(Sender: TObject);
begin
  AutoScale1.Checked := true;
  AutoScale := true;
  Displayheight := ScrollBox1.ClientHeight-1;
  ShowGraph;
  SpeedButton_AutoZoom.Enabled := false;
end;


procedure TForm_Main.Copygraph1Click(Sender: TObject);
begin
  Dot.CopyToClipBoard;
end;


procedure TForm_Main.Copybitmap1Click(Sender: TObject);
var
  MyFormat : Word;
  AData    : THandle;
  APalette : HPalette;
begin
  Image1.Picture.Bitmap.SaveToClipBoardFormat(MyFormat,AData,APalette);
  ClipBoard.SetAsHandle(MyFormat,AData);
end;


procedure TForm_Main.Undo1Click(Sender: TObject);
begin
  HistoryBack;
end;


procedure TForm_Main.Redo1Click(Sender: TObject);
begin
  HistoryForward;
end;


procedure TForm_Main.Exit1Click(Sender: TObject);
begin
  close;
end;


{--- TForm_Main (Unit analysis) -----------------------------------------------}


FUNCTION TForm_Main.UnitInGraph(UnitName: string): boolean;
{ - Unit is part of the graph? }
VAR
  i : integer;
  SL: TStringList;
BEGIN
  Result := false;
  SL := TStringList.Create;
  SL.Assign(CheckListBox_Units.Items);
  SL.CaseSensitive := false;
  i := SL.IndexOf(UnitName);
  SL.Free;
  IF i >= 0 then
    Result := CheckListBox_Units.State[i] IN [cbChecked, cbGrayed];
END;



FUNCTION TForm_Main.UnitShowChilds(UnitName: string): boolean;
{ Show child Units for that Unit? Depends on user setting and result of code analysis ) }
VAR
  i : integer;
  SL: TStringList;
BEGIN
  Result := false;
  SL := TStringList.Create;
  SL.Assign(CheckListBox_Units.Items);
  SL.CaseSensitive := false;
  i := SL.IndexOf(UnitName);
  SL.Free;
  IF i >= 0 then
    Result := CheckListBox_Units.State[i] IN [cbChecked];
END;


FUNCTION TForm_Main.UnitHasSource(UnitName: string): boolean;
{ Sourcecode available for that Unit? }
VAR
  i : integer;
BEGIN
  Result := false;
  i := Units.IndexOf(UnitName);
  IF i >= 0 then
    Result := (integer(Status.Items[i]) and CHasSource) > 0;
END;


FUNCTION TForm_Main.UnitParseError(UnitName: string): boolean;
{ Did an error occur while parsing that Unit? }
VAR
  i : integer;
BEGIN
  Result := true;
  i := Units.IndexOf(UnitName);
  IF i >= 0 then
    Result := (integer(Status.Items[i]) and CParseError) > 0;
END;




FUNCTION TForm_Main.GetUnitIndex(UnitName: string): integer;
{ Get index of Unit within Graph }
BEGIN
  Result := Units.IndexOf(UnitName);
END;



procedure TForm_Main.ShowGraph;
{ Display Graph. If neccessary call DOT.exe }
var
  x, y : double;
  bm   : TBitmap;
begin
  if not Dot.DotAvailable then
    exit;
  if Dot.IsRunning then
    begin
      StatusBar1.Panels[0].Text := ' Stopping DOT...';
      StopDOT := true;
      exit;
    end;
  StopDOT := false;
  StatusBar1.Panels[0].Text := ' Calling DOT...';
  if Dot.IsDirty then
    Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
  Dot.Refresh;
  Application.ProcessMessages;
  if Dot.IsDirty then
    begin
      if Dot.DotAvailable then
        PostMessage(self.Handle, Msg_ShowDOT, 0, 0);
      exit;
    end;
  bm := TBItmap.create;
  bm.PixelFormat := pf24bit;
  IF AutoScale then
    begin
      Dot.GetNativeGraphDimension(X, Y);
      IF (X > 0) and (Y > 0) then
        begin
          Dot.Width := ScrollBox1.ClientWidth-1;
          IF Dot.Height >= ScrollBox1.ClientHeight then
            Dot.Height := ScrollBox1.ClientHeight-1;
        end
        else Dot.Height := ScrollBox1.ClientHeight-1;
      DisplayHeight := Dot.Height;
    end
    else begin
      //Dot.Height := ScrollBox1.ClientHeight-1;
      Dot.Height := DisplayHeight;
    end;

  Dot.GetBitmap(bm);
  Image1.Picture.Bitmap.Assign(bm);
  BM.Free;
  BM := nil;
  Image1.Width := Image1.picture.Bitmap.Width;
  Image1.Height := Image1.picture.Bitmap.height;
  Image1.Refresh;
  IF DisplayUnit = ''
    then Label_UnitOnDisplay.caption := ''
    else begin
      IF Reverse
        then Label_UnitOnDisplay.caption := 'Bottom-Up tree for Unit "' + DisplayUnit +'"'
        else Label_UnitOnDisplay.caption := 'Top-Down tree for Unit "' + DisplayUnit +'"';
    end;
  Screen.Cursor := crDefault;
  StatusBar1.Panels[0].Text := '';
end; {TForm_Main.ShowGraph}




{ BuildGraphFromUnit prepares the graph starting with the currently selected unit.
 To show the Graph call ShowGraph}
procedure TForm_Main.BuildGraphFromUnit(UnitName: string);
var
  i        : integer;
  NodeCount: integer;


        PROCEDURE ProcessUnit(Name: string);


            PROCEDURE AddEdges(s1: string; SourceID: integer);
            VAR
              Dest : integer;
              s2   : string;
            begin
              Application.ProcessMessages;
              IF BailOut then
                exit;
               WHILE Length(s1) > 0 DO
                 BEGIN
                    s2 := copy(s1, 1, Pos(#1, s1)-1);
                    delete(s1, 1, Length(s2)+1);
                    IF UnitInGraph(s2) then
                      begin
                         Dest := GetUnitIndex(s2);
                         IF (Dest >= 0) and (TNode(NodeIndex.Items[Dest]).DotID = -1) then
                           ProcessUnit(s2);
                         IF (Dest >= 0) and (TNode(NodeIndex.Items[Dest]).DotID >= 0) then
                           begin
                             IF Reverse
                               then Dot.AddEdge(TNode(NodeIndex.Items[Dest]).DotID, TNode(NodeIndex.Items[SourceID]).DotID, '')
                               else Dot.AddEdge(TNode(NodeIndex.Items[SourceID]).DotID, TNode(NodeIndex.Items[Dest]).DotID, '');
                           end;
                      end;
                   IF BailOut then
                     exit;
                 END; {WHILE Length(s1)}
            end; {ProcessUnit.AddEdges}

        VAR
          Index     : integer;
          Color     : TColor;
          ShowChilds: boolean;
          BoxType   : TBoxType;
        BEGIN
          Application.ProcessMessages;
          IF BailOut then
            exit;
          Index := Units.IndexOf(Name);
          IF Index < 0 then
            exit;
          IF (Index >= NodeIndex.Count) or (Index >= Status.Count) then
            exit;
          IF TNode(NodeIndex.Items[Index]).DotID = -1 then
            begin
              Color := $00F0FFFF;
              ShowChilds := UnitShowChilds(Name);
              IF ShowChilds
                then BoxType := BT_Box
                else BoxType := BT_Ellipse;

              IF integer(Status.Items[Index]) and CHasForm > 0
                then Color := $00E8FFE0;

              IF integer(Status.Items[Index]) and CParseError <> 0
                then begin
                  BoxType := BT_Hexagon;
                  Color := $00E0E0F8;
                  if not Reverse then
                    ShowChilds := false;
                end;

              IF integer(Status.Items[Index]) and CHasSource = 0
                then begin
                  BoxType := BT_Ellipse;
                  Color := $00E0E0E0;
                  if not Reverse then
                    ShowChilds := false;
                end;

              if HighlightNew then
                begin
                  if (FileDate.Count > Index) and (integer(FileDate.Items[Index]) <> -1) then
                    if trunc(DateTimePicker1.DateTime) < FileDateToDateTime(integer(FileDate.Items[Index])) then
                      begin
                        //BoxType := BT_Hexagon;
                        Color := $00C0D0FF;
                      end;
                end;

              if Trim(Units.Strings[Index]) = '' then // Name?
                Units.Strings[Index] := IntToStr(Index);
              TNode(NodeIndex.Items[Index]).DotID:= Dot.AddNode(BoxType, Color, Units.Strings[Index]);
              Inc(NodeCount);
              IF ShowChilds THEN
                begin
                  if Reverse then
                    begin
                      AddEdges(UsedBy1.Strings[Index], Index);
                      AddEdges(UsedBy2.Strings[Index], Index);
                    end
                    else begin
                      AddEdges(Uses1.Strings[Index], Index);
                      AddEdges(Uses2.Strings[Index], Index);
                    end;
                end;
            end;
        END;



begin
  Speedbutton_Refresh.Enabled := false;
  fBuildGraph := true;
  NodeCount := 0;
  StatusBar1.Panels[0].Text := ' Building Graph...';
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
  Dot.Clear;
  NodeIndex.Clear;
  FOR i := 0 TO Units.Count-1 DO   
    NodeIndex.AddNode(-1);  // Listenplatz belegen: ein Eintrag pro Unit in Liste
  try
    ProcessUnit(UnitName);    // Start of recursive call
  except
  end;  
  DisplayUnit := UnitName;
  StatusBar1.Panels[0].Text := '';
  StatusBar1.Panels[2].Text := ' ' + IntToStr(NodeCount) + ' of ' + IntToStr(Units.Count);
  Screen.Cursor := crDefault;
  fBuildGraph := false;
  Speedbutton_Refresh.Enabled := not CheckBox_AutoRefresh.Checked;
end;




PROCEDURE TForm_Main.ReadDefAndSwitch(FN: string; VAR Defines, Switches: string);
{ - Reads defines and compiler switches from pascal config file. No error return so far... }
VAR
  t  : textfile;
  s  : string;
  FM : byte;


        FUNCTION ExtractCSToken(VAR St: string): string;
        VAR
          s : string;
        BEGIN
          s  := copy(st+',', 1, Pos(',', st+','));
          st := copy(st, Length(s)+1, Length(st));
          delete(s, Length(s), 1);  // Remove ","
          Result := s;
        END;


BEGIN
  Switches := '';
  Defines := '';
  IF FN = '' then
    EXIT;
  IF not(FileExists(FN)) then
    exit;
  FM := FileMode;
  FileMode := 0;
  try
    assignfile(t, FN);
    reset(t);
  except
    FileMode := 2;
    exit;
  end;
  FileMode := 2;
  try
    REPEAT
      readln(t, s);
      IF (Pos('/$', s) = 1) or (Pos('-$', s) = 1) then
        begin
          delete(s, 1, 2);
          IF Length(s) > 1 then
            IF s[1] <> 'M' then
              while Length(s) > 1 do
                Switches := Switches + ',' + Trim(ExtractCSToken(s));
        end;
      IF (Pos('/D', s) = 1) or (Pos('-D', s) = 1) then
        begin
          delete(s, 1, 2);
          while Length(s) > 1 do
            Defines := Defines + ',' + Trim(ExtractCSToken(s));
        end;
    UNTIL eof(t);
  finally
    closefile(t);
  end;
  delete(Defines, 1, 1);
  delete(Switches, 1, 1);
END;




procedure TForm_Main.BuildReverseTree;
{ Creates the reverse Unit-usage list, e.g. UsedBy1 is the reverse list for Uses1 }
var
  i, j : integer;
  Name : string;
begin
  UsedBy1.Clear;
  UsedBy2.Clear;
  FOR i := 0 TO Units.Count-1 DO
    begin
      UsedBy1.Add('');
      UsedBy2.Add('');
      Name := #1 + UpperCase(Units.Strings[i]) + #1;
      FOR j := 0 TO Units.Count-1 DO
        IF i <> j then
          begin
            IF Pos(Name, #1 + UpperCase(Uses1.Strings[j])) > 0 then
              UsedBy1.strings[i] := UsedBy1.strings[i] + Units.Strings[j] + #1;
            IF Pos(Name, #1 + UpperCase(Uses2.Strings[j])) > 0 then
              UsedBy2.strings[i] := UsedBy2.strings[i] + Units.Strings[j] + #1;
          end;
    end;
end;


procedure TForm_Main.ProcessFile(FileName: string);
{ Run analysis for given source file }
var
  Source      : TStringList;
  SLIn,
  SLOut       : TSourceList;
  Index, i, j : integer;
  st, UStr,
  s2,
  ErrMsg      : string;
  _Defines,
  _Settings   : string;


  procedure processUses;
  begin
     delete(st, 1, i+5);
     UStr := copy(st, 1, Pos(';', st)-1)+',';
     WHILE Length(UStr) > 1 do
        begin
          s2 := copy(UStr, 1, Pos(',', UStr)-1);
          delete(UStr, 1, Length(s2)+1);
          s2 := Trim(s2)+' ';
          delete(s2, Pos(' ', s2), 1024);
          Uses1.Strings[Index] := Uses1.Strings[Index]+s2+#1;
          IF Units.IndexOf(s2) < 0 then
            ProcessFile(IncludeTrailingPathDelimiter(ExtractFilePath(FileName)) + s2 + '.pas');
        end;
  end;

begin
  Application.processmessages;
  IF BailOut then
    exit;
  Units.Add(ExtractFileName(ChangeFileExt(FileName, '')));
  Index := Units.Count-1;
  Uses1.Add('');
  Uses2.Add('');
  Status.Add(pointer(0));
  FileDate.Add(pointer(-1));
  CheckListBox_Units.Items.Add(Units.Strings[Index]);

  _Defines := Label_CompilerRelatedDirectives.Caption;
  if Trim(Edit_Defines.Text) <> '' then
    _Defines := _Defines + ','+Edit_Defines.Text;
  _Settings := DefaultSwitch;
  IF Trim(Edit_Directives.Text) <> '' then
    _Settings := _Settings + ',' + Edit_Directives.Text;

  FileName := FileSearch(ExtractFileName(FileName), SearchPath);

  IF (FileName = '') or not(FileExists(FileName)) then
    exit;

  FileDate.Items[Index] := (pointer(FileAge(FileName)));

  CheckListBox_Units.Checked[Index] := true;
  CheckListBox_Units.State[Index] := cbChecked;
  Status.Items[Index] := pointer(CHasSource);
  IF (FileExists(ChangeFileExt(FileName, '.dfm'))) then
    Status.Items[Index] := pointer(CHasSource or CHasForm);

  Source := TStringList.Create;
  SLIn   := TSourceList.Create;
  SLOut  := TSourceList.Create;

  try
    StatusBar1.Panels[1].Text := ' Parsing ' + FileName + '...';
    Application.processMessages;
    Source.Clear;
    SLIn.Clear;
    SLOut.Clear;
    i := RemoveDeadCode(FileName, SLIn, SLOut, nil, nil, [PA_DelStrings, PA_DelComments, PA_DelDirectives], SearchPath, _Defines, _Settings, ErrMsg);
    st := '';
    FOR j := 1 TO SLOut.Count-1 DO
      st := st + TAnnotatedStringList(SLOut.Items[j]).SourceName + ', ';
    IF Length(st) > 0 then
      begin
        delete(st, Length(st)-1, 2);
        st :=' [Includes: '+st+' ]';
      end;
    if i = 0
      then Memo_Watch.Lines.Add(FileName + ' parsed.'+st)
      else begin
        Memo_Watch.Lines.Add(FileName + ' parsing error: "'+ErrMsg+'"'+st);
        Status.Items[Index] := pointer(integer(Status.Items[Index]) or CParseError);
      end;
    IF SLOut.Count > 0
      then Source.Assign(TStringList(SLOut.Items[0]))
      else Source.Clear;
    //st := AnsiReplaceText(Source.Text, #13, #32); // Remove line feeds
    st := Source.Text;
    Source.Free;
    Source := nil;
    {
    st := AnsiReplaceText(st, #10, #32); // Remove line feeds
    st := AnsiReplaceText(st,  #9, #32); // Remove TABs
    }
    // Analyze USES directive, but only, if source code successfully has been cleaned.
    IF i = 0 then
      begin
        FOR i := 1 TO Length(st) DO
          IF (st[i]=#9) or (st[i]=#10) or (st[i]=#13) then
            st[i] := ' ';
        i := Pos(' USES ', Uppercase(st));  // First USES directive
        IF i > 0 then
          begin
            ProcessUses;
            i := Pos(' USES ', Uppercase(st));  // Second USES directive
            IF i > 0 then
              ProcessUses;
          end;
      end
      else Inc(ParseErrorCnt);
  finally
    if assigned(Source) then
      Source.Free;
    StatusBar1.Panels[1].Text := '';
    SLOut.Free;
    SLIn.Free;
  end;
end; {ProcessFile}



procedure TForm_Main.Analyze(MainFile: string);
{ Run analysis for given source file (Calls ProcessFile)}
begin
  StatusBar1.Panels[0].Text := ' Parsing files...';
  Application.ProcessMessages;
  SourcePath := ExtractFilePath(MainFile);
  Units.Clear;
  Uses1.Clear;
  Uses2.Clear;
  UsedBy1.Clear;
  UsedBy2.Clear;
  Status.Clear;
  FileDate.Clear;
  CheckListBox_Units.Items.Clear;
  CheckListBox_Units.Sorted := false;
  ProcessFile(MainFile);
  BuildReverseTree;
  CheckListBox_Units.Sorted := true;
  StatusBar1.Panels[0].Text := '';
end;









CONST
  SectionGraph  = 'Graph';
  SectionSource = 'Source';

PROCEDURE TForm_Main.SaveProject(const FileName: string);
VAR
  i, j      : integer;
  IniFile   : TMemIniFile;
  MemStream : TMemoryStream;

        FUNCTION CleanStr(const s: string): string;
        BEGIN
          Result := AnsiReplacetext(AnsiReplaceText(s, #13#10, ','), #1, '?');
        END;

BEGIN
  IniFile   := nil;
  MemStream := nil;
  try
    IniFile := TMemIniFile.Create(FileName);
    IniFile.WriteDate('About', 'DateTime', Now);

    IniFile.WriteString(SectionSource, 'MainFile', MainFile);
    IniFile.WriteString(SectionSource, 'Defines', AnsiReplaceText(Defines, ';', '?'));
    IniFile.WriteString(SectionSource, 'Directives', AnsiReplaceText(Settings, ';', '?'));
    IniFile.WriteString(SectionSource, 'SearchPath', AnsiReplaceText(Edit_SearchPath.Text, ';', '?'));

    IniFile.WriteString(SectionGraph, 'Units', CleanStr(Units.Text));
    IniFile.WriteString(SectionGraph, 'Uses1', CleanStr(Uses1.Text));
    IniFile.WriteString(SectionGraph, 'Uses2', CleanStr(Uses2.Text));
    IniFile.WriteString(SectionGraph, 'UsedBy1', CleanStr(UsedBy1.Text));
    IniFile.WriteString(SectionGraph, 'UsedBy2', CleanStr(UsedBy2.Text));
    IniFile.WriteString(SectionGraph, 'UnitSelected', DisplayUnit);
    IniFile.WriteBool(SectionGraph, 'BottomUp', Reverse);
    IniFile.WriteBool(SectionGraph, 'HighlightCR', CheckBox_HighlightCircular.Checked);
    IniFile.WriteBool(SectionGraph, 'HighlightNew', CheckBox_HighlightNew.Checked);
    IniFile.WriteInteger(SectionGraph, 'HighlightDate', round(DateTimePicker1.DateTime));

    MemStream := TMemoryStream.Create;

    MemStream.Clear;
    FOR i := 0 TO Status.Count-1 DO
      begin
        j := integer(Status.Items[i]);
        MemStream.Write(j, SizeOf(j));
      end;
    MemStream.Seek(0, soFromBeginning);
    IniFile.WriteBinaryStream(SectionGraph, 'Status', MemStream);

    MemStream.Clear;
    FOR i := 0 TO CheckListBox_Units.Count-1 DO
      begin
        j := integer(CheckListBox_Units.State[i]);
        MemStream.Write(j, SizeOf(j));
      end;
    MemStream.Seek(0, soFromBeginning);
    IniFile.WriteBinaryStream(SectionGraph, 'Selection', MemStream);

    MemStream.Clear;
    FOR i := 0 TO FileDate.Count-1 DO
      begin
        j := integer(FileDate.Items[i]);
        MemStream.Write(j, SizeOf(j));
      end;
    MemStream.Seek(0, soFromBeginning);
    IniFile.WriteBinaryStream(SectionGraph, 'FileDate', MemStream);

    IniFile.UpdateFile;
  finally
    IF assigned(IniFile) then
      IniFile.Free;
    IF assigned(MemStream) then
      MemStream.Free;
  end;
END;


PROCEDURE TForm_Main.OpenProject(const FileName: string);
VAR
  i, j      : integer;
  IniFile   : TMemIniFile;
  MemStream : TMemoryStream;

        FUNCTION RebuildStr(const s: string): string;
        BEGIN
          Result := AnsiReplacetext(AnsiReplaceText(s, ',', #13#10), '?', #1);
        END;

BEGIN
  IniFile   := nil;
  MemStream := nil;
  try
    IniFile := TMemIniFile.Create(FileName);

    MainFile := IniFile.ReadString(SectionSource, 'MainFile', '');
    Defines  := IniFile.ReadString(SectionSource, 'Defines', '');
    Defines := AnsiReplaceText(Defines, '?', ';');
    Settings := IniFile.ReadString(SectionSource, 'Directives', '');
    Settings := AnsiReplaceText(Settings, '?', ';');
    Edit_SearchPath.Text := AnsiReplaceText(IniFile.ReadString(SectionSource, 'SearchPath', ''), '?', ';');
    SearchPath := Edit_SearchPath.Text;
    Edit_MainFileName.Text := MainFile;
    Edit_Defines.Text := Defines;
    Edit_Directives.Text := Settings;

    Units.Clear;
    Units.Text := RebuildStr(IniFile.ReadString(SectionGraph, 'Units', ''));
    Uses1.Clear;
    Uses1.Text := RebuildStr(IniFile.ReadString(SectionGraph, 'Uses1', ''));
    Uses2.Clear;
    Uses2.Text := RebuildStr(IniFile.ReadString(SectionGraph, 'Uses2', ''));
    UsedBy1.Clear;
    UsedBy1.Text := RebuildStr(IniFile.ReadString(SectionGraph, 'UsedBy1', ''));
    UsedBy2.Clear;
    UsedBy2.Text := RebuildStr(IniFile.ReadString(SectionGraph, 'UsedBy2', ''));

    DisplayUnit := IniFile.ReadString(SectionGraph, 'UnitSelected', '');
    Reverse     := IniFile.ReadBool(SectionGraph, 'BottomUp', false);
    CheckBox_HighlightCircular.Checked := IniFile.ReadBool(SectionGraph, 'HighlightCR', true);
    CheckBox_HighlightNew.Checked := IniFile.ReadBool(SectionGraph, 'HighlightNew', false);
    DateTimePicker1.DateTime := IniFile.ReadInteger(SectionGraph, 'HighlightDate', round(Now));

    MemStream := TMemoryStream.Create;

    MemStream.Clear;
    IniFile.ReadBinaryStream(SectionGraph, 'Status', MemStream);
    MemStream.Seek(0, soFromBeginning);
    Status.Clear;
    WHILE MemStream.Position < MemStream.Size DO
      BEGIN
        MemStream.Read(j, SizeOf(j));
        Status.Add(pointer(j));
      end;

    CheckListBox_Units.Clear;
    CheckListBox_Units.Items.Assign(Units);
    CheckListBox_Units.Sorted := true;
    MemStream.Clear;
    IniFile.ReadBinaryStream(SectionGraph, 'Selection', MemStream);
    MemStream.Seek(0, soFromBeginning);
    i := 0;
    WHILE MemStream.Position < MemStream.Size DO
      BEGIN
        MemStream.Read(j, SizeOf(j));
        CheckListBox_Units.State[i] := TCheckBoxState(j);
        Inc(i);
      end;

    MemStream.Clear;
    IniFile.ReadBinaryStream(SectionGraph, 'FileDate', MemStream);
    MemStream.Seek(0, soFromBeginning);
    FileDate.Clear;
    WHILE MemStream.Position < MemStream.Size DO
      BEGIN
        MemStream.Read(j, SizeOf(j));
        FileDate.Add(pointer(j));
      end;

    IniFile.UpdateFile;
  finally
    IF assigned(IniFile) then
      IniFile.Free;
    IF assigned(MemStream) then
      MemStream.Free;
  end;
END;


procedure TForm_Main.ScrollBox1Resize(Sender: TObject);
begin
  ShowGraph;
end;


procedure TForm_Main.CheckListBox_UnitsDblClick(Sender: TObject);
begin
  IF CheckBox_AutoRefresh.Checked and (CheckListBox_Units.ItemIndex >= 0) then
    begin
      BuildGraphFromUnit(CheckListBox_Units.Items[CheckListBox_Units.ItemIndex]);
      ShowGraph;
      HistoryAdd;
    end;
end;



procedure TForm_Main.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i, j : integer;
  s    : string;
  SL   : TStringList;
begin
  IF Button = mbRight then
    begin
      IF fBuildGraph then
        exit;
      i := Dot.FindNodeAtPixelXY(X, Y);
      IF i >= 0 then
        begin
          FOR j := PopupMenu1.Items.Count-1 DOWNTO 6 DO
            PopupMenu1.Items[j].Free;
          s := Dot.GetNodeCaption(i);
          j := GetUnitIndex(s);
          IF j < 0 then
            exit;  // Programming error
          SL:= TStringList.Create;
          IF Reverse
            then SL.Text := AnsiReplaceText(Uses1.Strings[j], #1, #13#10) + AnsiReplaceText(Uses2.Strings[j], #1, #13#10)
            else SL.Text := AnsiReplaceText(UsedBy1.Strings[j], #1, #13#10) + AnsiReplaceText(UsedBy2.Strings[j], #1, #13#10);
          SL.Sorted := true;
          FOR j := 0 TO SL.Count-1 DO
            BEGIN
              PopupMenu1.Items.add(TMenuItem.Create(PopupMenu1));
              PopupMenu1.Items[PopupMenu1.Items.Count-1].Caption := SL.Strings[j];
              PopupMenu1.Items[PopupMenu1.Items.Count-1].Tag := Units.IndexOf(SL.Strings[j])+1000;
              PopupMenu1.Items[PopupMenu1.Items.Count-1].OnClick := SelectUnitClick;
            END;
          SL.Free;  
          i := CheckListBox_Units.Items.IndexOf(s);
          IF i >= 0 then
            begin
              FOR j := 0 TO 2 DO
                begin
                  PopupMenu1.Items[j+2].Checked := false;
                  PopupMenu1.Items[j+2].Tag := i;
                end;
              IF CheckListBox_Units.State[i] = cbGrayed
                then PopupMenu1.Items[3].Checked := true
                else PopupMenu1.Items[2].Checked := true;
              PopupMenu1.Items[0].Caption := 'View ' + s;
              PopupMenu1.Items[0].Enabled := UnitHasSource(s);
              MouseOverUnit := s;
              PopupMenu1.Popup(Left+Panel_Right.Left+X+Image1.left, Top+Panel_Right.top+Height-Clientheight+Y);
            end
            else exit;  // Programming error
        end;
    end;
  {
  IF Button = mbLeft then
    begin
      MoveX0 := X;
      MoveY0 := Y;
    end;
  }  
end;



procedure TForm_Main.Image1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
VAR
  i, j,
  MoveX, MoveY : integer;
  s, s2, s3    : string;
  l            : TStringList;
begin
  IF fBuildGraph
    then exit;
  i := Dot.FindNodeAtPixelXY(X, Y);
  IF i < 0
    then s := ''
    else s := Dot.GetNodeCaption(i);

  { Move graph with mouse. Does not work :(
  IF Shift = [ssLeft] then
    begin
      MoveX := X - MoveX0;
      MoveY := Y - MoveY0;
      ScrollBox1.ScrollBy(MoveX, MoveY);
      MoveX0 := X;
      MoveY0 := Y;
      exit;
    end; }

  IF s = MouseOverUnit then
    EXIT;

  MouseOverUnit := s;

  Dot.SelNode := i;
  ShowGraph;
  IF i >= 0 then
    begin
      j := GetUnitIndex(s);
      IF j >= 0 then
        begin
          l := TStringList.Create;
          l.Text := AnsiReplaceText(Uses1.Strings[j], #1, #13#10) + AnsiReplaceText(Uses2.Strings[j], #1, #13#10);
          l.Sorted := true;
          s2 := AnsiReplaceText(l.Text, #13#10, ', ');
          l.Text := AnsiReplaceText(UsedBy1.Strings[j], #1, #13#10) + AnsiReplaceText(UsedBy2.Strings[j], #1, #13#10);
          s3 := AnsiReplaceText(l.Text, #13#10, ', ');
          IF (Length(s2) > 1) or (Length(s3) > 1) then
            begin
              delete(s2, Length(s2)-1, 2);
              delete(s3, Length(s3)-1, 2);
              s2 := s2 + #10 + s3;
            end;
          s2 := s + #10 + s2;
          l.free;
        end;
      IF fHighLightMU then
        begin
          j := CheckListBox_Units.Items.IndexOf(s);
          IF j >= 0 then
            CheckListBox_Units.ItemIndex := j;
        end;
    end;

  IF i < 0
    then StatusBar1.Panels[1].Text := ''
    else StatusBar1.Panels[1].Text := s2;
  Application.ProcessMessages;  // Without this line sometimes the text is not displayed.
end;


procedure TForm_Main.Image1DblClick(Sender: TObject);
var
  X, Y, i : integer;
begin
  X := Mouse.CursorPos.X - Clientorigin.X - Panel_Right.Left - ScrollBox1.Left - Image1.Left;
  Y := Mouse.CursorPos.Y - Clientorigin.Y - Panel_Right.Top - ScrollBox1.Top - Image1.Top;
  i := Dot.FindNodeAtPixelXY(X, Y);
  IF i > 0 then
    begin
      BuildGraphFromUnit(Dot.GetNodeCaption(i));
      ShowGraph;
      HistoryAdd;
    end;
end;

procedure TForm_Main.CheckListBox_UnitsClickCheck(Sender: TObject);
begin
  IF CheckBox_AutoRefresh.Checked then
    begin
      BuildGraphFromUnit(DisplayUnit);
      ShowGraph;
      HistoryAdd;
    end;
end;


procedure TForm_Main.SelectUnitClick(Sender: TObject);
begin
  WITH Sender as TMenuItem DO
    IF Tag >= 1000 then
      begin
        BuildGraphFromUnit(Units.Strings[Tag-1000]);
        ShowGraph;
        HistoryAdd;
      end;
end;



procedure TForm_Main.BitBtn1Click(Sender: TObject);
VAR
  i : integer;
begin
  FOR i := 0 TO CheckListBox_Units.Count-1 DO
    CheckListBox_Units.State[i] := cbChecked;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  HistoryAdd;
end;


procedure TForm_Main.BitBtn2Click(Sender: TObject);
VAR
  i : integer;
begin
  FOR i := 0 TO CheckListBox_Units.Count-1 DO
    CheckListBox_Units.State[i] := cbUnChecked;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  HistoryAdd;  
end;


procedure TForm_Main.ZoomIn;
begin
  AutoScale := false;
  AutoScale1.Checked := false;
  SpeedButton_AutoZoom.Enabled := true;
  DisplayHeight := ((DisplayHeight + 20) div 20) *20;
  IF Displayheight > 4000
    then Displayheight := 4000;
  ShowGraph;
end;


procedure TForm_Main.ZoomOut;
begin
  AutoScale := false;
  AutoScale1.Checked := false;
  SpeedButton_AutoZoom.Enabled := true;
  DisplayHeight := ((DisplayHeight - 20) div 20) *20;
  IF Displayheight < 80
    then Displayheight := 80;
  ShowGraph;
end;


procedure TForm_Main.ScrollBox1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  {
  IF AutoScale then
    exit;
  }  
  ZoomIn;
  Handled := true;
end;


procedure TForm_Main.ScrollBox1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  {
  IF AutoScale then
    exit;
  }
  ZoomOut;
  Handled := true;
end;


procedure TForm_Main.FormMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  ZoomIn;
  Handled := true;
end;


procedure TForm_Main.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ZoomOut;
  Handled := true;
end;


procedure TForm_Main.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
  Name, s : string;
  l       : integer;
begin
  with StatusBar.Canvas DO
    begin
      if Panel.Text = '' then
        begin
          Brush.Color := clBtnFace;
          Pen.Color := clBtnFace;
        end
        else begin
          IF Panel = StatusBar1.Panels[0] then
            begin
              Brush.Color := $00C0C0D0;
              Pen.Color := $00C0C0D0;
            end
            else begin
              Brush.Color := $00C0D0C0;
              Pen.Color := $00C0D0C0;
            end;
        end;
        rectangle(Rect);
        IF Pos(#10, Panel.Text) = 0
          then TextOut(Rect.Left, Rect.Top + (Rect.Bottom-Rect.Top-Textheight('H')) div 2, ' ' + Panel.Text)
          else begin
            s := Panel.Text;
            Name := copy(s, 1, Pos(#10, Panel.Text)-1);
            delete(s, 1, Length(Name)+1);
            Name := Name + ' ';
            l := TextWidth(Name+' ');
            TextOut(Rect.Left, Rect.Top + (Rect.Bottom-Rect.Top-Textheight('H')) div 2, ' ' + Name);
            Name := Font.Name;
            Font.Name := 'Symbol';
            Font.Color := $000000C0;
            TextOut(Rect.Left+l, Rect.Top, '  ');
            Font.Color := clGreen;
            TextOut(Rect.Left+l, Rect.Top + Textheight('H'), '  ');
            Font.Color := clBlack;
            l := l + TextWidth('    ');
            Font.Name := Name;
            TextOut(Rect.Left+l, Rect.Top+1, ' ' + copy(s, 1, Pos(#10, s)-1));
            TextOut(Rect.Left+l, Rect.Top+1 + Textheight('H'), ' ' + copy(s, Pos(#10, s)+1, 4096));
          end;
    end;
end;


procedure TForm_Main.FormResize(Sender: TObject);
begin
  StatusBar1.Panels[1].Width := ClientWidth - StatusBar1.Panels[0].Width - Canvas.TextWidth(' 9999 of 9999   ');
end;


procedure TForm_Main.ActivateButtons;
begin
  SpeedButton_Home.Enabled := true;
  SpeedButton_SelectAll.Enabled := true;
  SpeedButton_SelectNone.Enabled := true;
  SpeedButton_SelectSource.Enabled := true;
  SpeedButton_BottomUp.Enabled := not Reverse;
  SpeedButton_TopDown.Enabled := Reverse;
  SpeedButton_Save.Enabled := true;
  SpeedButton_SaveProject.Enabled := true;
  SpeedButton_CopyToClipboard.enabled := true;
  SpeedButton_Print.enabled := true;
  SpeedButton_ZoomIn.Enabled := true;
  SpeedButton_ZoomOut.Enabled := true;
  SpeedButton_AutoZoom.Enabled := true;

  Saveproject1.Enabled := ProjectName <> '';
  SaveprojectAs1.enabled := true;
  Selectunitswithsourceonly1.Enabled := true;
  SelectAll1.enabled := true;
  UnSelectAll1.enabled := true;
  CopyGraph1.Enabled := true;
  CopyBitmap1.Enabled := true;

  SpeedButton_Previous.Enabled := (HistoryIndex > 0);
  SpeedButton_Next.Enabled := (HistoryIndex < CMaxHistory) and
                              (PHistory[HistoryIndex+1]^.H_InUse);
  Undo1.Enabled := SpeedButton_Previous.Enabled;
  Redo1.Enabled := SpeedButton_Next.Enabled;
end;


procedure TForm_Main.SpeedButton_BuildGraphClick(Sender: TObject);
var
  T1, T2, i : integer;
begin
  IF fProcessGraph then
    exit;
  fProcessGraph := true;
  ParseErrorCnt := 0;
  BailOut := false;
  IF not (Dot.DotAvailable) then
    begin
      MessageDlg('DOT.exe not found!'#10+
                 'In order to display a graph you need to specify the path where to find DOT.exe.'#10#10+
                 'You can download DOT.exe from www.graphviz.org.'#10+
                 'DOT.exe is part of GraphViz.'#10#10+
                 'After installation of GraphViz open UnitUsage''s options dialog to specify the path where to find dot.exe.', mtError, [mbOK], 0);
      fProcessGraph := false;
      exit;
    end;

  Reverse := false;
  MainFile := Trim(Edit_MainFileName.Text);
  SearchPath := ExcludeTrailingPathDelimiter(ExtractFilePath(MainFile)) + ';' + Trim(Edit_SearchPath.Text);
  Memo_Watch.Lines.Clear;
  IF (MainFile <> '') and FileExists(MainFile) then
    begin
      SpeedButton_BuildGraph.Enabled := false;
      Screen.Cursor := crHourGlass;
      Application.ProcessMessages;
      T1 := TimeGetTime;
      Analyze(MainFile);
      T2 := TimeGetTime;
      Memo_Watch.Lines.Add('Time: ' + FloatToStrF((T2-T1)/1000, ffFixed, 16, 1)+'sec.');
      IF ParseErrorCnt > 0 then
        Memo_Watch.Lines.Add('Error parsing ' + IntToStr(ParseErrorCnt) + ' file(s). No "child" units will be displayed for these units.');
      SpeedButton_BuildGraph.Enabled := true;

      FOR i := 0 TO CheckListBox_Units.Count-1 DO
        IF UnitHasSource(CheckListBox_Units.Items[i])
          then CheckListBox_Units.State[i] := cbChecked
          else CheckListBox_Units.State[i] := cbUnChecked;

      BuildGraphFromUnit(ExtractFilename(ChangeFileExt(MainFile, '')));

      ShowGraph;

      Screen.Cursor := crDefault;
      HistoryClear;
      HistoryAdd;
      ActivateButtons;
    end;
  fProcessGraph := false;
end;


procedure TForm_Main.Edit_MainFileNameChange(Sender: TObject);
begin
  SpeedButton_BuildGraph.Enabled := FileExists(Edit_MainFileName.Text);
end;


procedure TForm_Main.SpeedButton_SelectAllClick(Sender: TObject);
VAR
  i : integer;
begin
  FOR i := 0 TO CheckListBox_Units.Count-1 DO
    CheckListBox_Units.State[i] := cbChecked;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  HistoryAdd;
end;


procedure TForm_Main.SpeedButton_SelectNoneClick(Sender: TObject);
VAR
  i : integer;
begin
  FOR i := 0 TO CheckListBox_Units.Count-1 DO
    CheckListBox_Units.State[i] := cbUnChecked;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  HistoryAdd;  
end;


procedure TForm_Main.SpeedButton_SelectSourceClick(Sender: TObject);
VAR
  i : integer;
begin
  FOR i := 0 TO CheckListBox_Units.Count-1 DO
    IF UnitHasSource(CheckListBox_Units.Items[i])
      then CheckListBox_Units.State[i] := cbChecked
      else CheckListBox_Units.State[i] := cbUnChecked;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  HistoryAdd;
end;


procedure TForm_Main.SpeedButton_TopDownClick(Sender: TObject);
begin
  Reverse := false;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  SpeedButton_BottomUp.Enabled := not Reverse;
  SpeedButton_TopDown.Enabled := Reverse;
  HistoryAdd;
end;


procedure TForm_Main.SpeedButton_BottomUpClick(Sender: TObject);
begin
  Reverse := true;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  SpeedButton_BottomUp.Enabled := not Reverse;
  SpeedButton_TopDown.Enabled := Reverse;
  HistoryAdd;
end;


procedure TForm_Main.SpeedButton_QuitClick(Sender: TObject);
begin
  close;
end;


procedure TForm_Main.SpeedButton_SaveProjectClick(Sender: TObject);
VAR
  FN : string;
begin
  IF SaveDialog_Project.Execute then
    BEGIN
      FN := ChangeFileExt(SaveDialog_Project.FileName, '.uup');
      IF FileExists(FN) then
        IF MessageDlg('File ' + FN + ' already exists!'#10'Overwrite?', mtConfirmation, mbYesNoCancel, 0) <> mrYes
          THEN EXIT;
      SaveProject(FN);
      ProjectName := FN;
      Saveproject1.Enabled := true;
      Caption := ' UnitUsage   [' + ProjectName + ']';
    END;
end;



procedure TForm_Main.OpenProjectEx(const FN: string);
begin
  OpenProject(FN);
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  ProjectName:= FN;
  Saveproject1.Enabled:= true;
  HistoryClear;
  HistoryAdd;
  ActivateButtons;
  Caption := ' UnitUsage   [' + ProjectName + ']';
end;



procedure TForm_Main.SpeedButton_OpenProjectClick(Sender: TObject);
begin
  IF OpenDialog_Project.Execute then
    OpenProjectEx(OpenDialog_Project.FileName);
end;


procedure TForm_Main.Autoscale1Click(Sender: TObject);
begin
  AutoScale1.Checked:= not(AutoScale1.Checked);
  AutoScale:= AutoScale1.Checked;
  SpeedButton_AutoZoom.Enabled := not(AutoScale);
  IF not(AutoScale1.Checked) then
    Displayheight := ScrollBox1.ClientHeight-1;
  ShowGraph;
end;

procedure TForm_Main.SpeedButton_HomeClick(Sender: TObject);
begin
  DisplayUnit := ExtractFilename(ChangeFileExt(MainFile, ''));
  SpeedButton_TopDownClick(nil);
end;


procedure TForm_Main.SpeedButton_CopyToClipboardClick(Sender: TObject);
begin
  Dot.CopyToClipBoard;
end;


procedure TForm_Main.SpeedButton_LoadDefinesClick(Sender: TObject);
VAR
  Settings: string;
begin
  if OpenDialog_ConfigFile.Execute then
    begin
      ReadDefAndSwitch(OpenDialog_ConfigFile.FileName, Defines, Settings);
      Edit_Defines.Text := Defines;
    end;
end;


procedure TForm_Main.SpeedButton_DirectivesClick(Sender: TObject);
VAR
  Defines: string;
begin
  if OpenDialog_ConfigFile.Execute then
    begin
      ReadDefAndSwitch(OpenDialog_ConfigFile.FileName, Defines, Settings);
      Edit_Directives.Text := Settings;
    end;
end;


procedure TForm_Main.SpeedButton_SaveClick(Sender: TObject);
VAR
  JPEG : TJPEGImage;
begin
  IF SavePictureDialog1.Execute then
    begin
      IF Pos('BMP'#1, UpperCase(SavePictureDialog1.FileName+#1)) > 0
        then Image1.Picture.Bitmap.SaveToFile(SavePictureDialog1.FileName);
      IF Pos('WMF'#1, UpperCase(SavePictureDialog1.FileName+#1)) > 0
        then Dot.ExportToWMF(SavePictureDialog1.FileName);
      IF Pos('JPG'#1, UpperCase(SavePictureDialog1.FileName+#1)) > 0
        then begin
          JPEG := TJPegImage.Create;
          JPEG.JPEGNeeded;
          JPEG.Assign(Image1.Picture.Bitmap);
          JPEG.CompressionQuality := 85;
          JPEG.Compress;
          JPEG.SaveToFile(SavePictureDialog1.FileName);
          JPEG.Free;
        end;
    end;
end;


procedure TForm_Main.SpeedButton_LoadMainSourceFileClick(Sender: TObject);
begin
  IF OpenDialog1.execute then
    begin
      Edit_MainFileName.Text := OpenDialog1.FileName;
      ReadDefAndSwitch(ChangeFileExt(OpenDialog1.FileName, '.cfg'), Defines, Settings);
      Edit_Defines.Text := Defines;
      Edit_Directives.Text := Settings;
    end;
end;


procedure TForm_Main.Saveproject1Click(Sender: TObject);
begin
  SaveProject(ProjectName);
  Caption := ' UnitUsage   [' + ProjectName + ']';
end;


procedure TForm_Main.SpeedButton_PrintClick(Sender: TObject);
VAR
  R : TRect;
begin
  IF PrintDialog1.Execute then
    begin
      Printer.Title := 'UnitUsage';
      Printer.BeginDoc;
      R := Rect(round(Printer.PageWidth * 0.075),
                round(Printer.PageHeight * 0.075),
                round(Printer.PageWidth * 0.925),
                round(Printer.PageHeight * 0.925));
      Dot.PaintGraphToCanvas(Printer.Canvas, R , false);
      Printer.EndDoc;
    end;
end;


PROCEDURE TForm_Main.HistoryClear;
VAR
  i : integer;
BEGIN
  FOR i := 0 TO CMaxHistory DO
    WITH PHistory[i]^ DO
      BEGIN
        H_InUse       := false;
        H_Reverse     := false;
        H_DisplayUnit := '';
        SetLength(H_State, 0);
      END;
  HistoryIndex := -1;
END;


PROCEDURE TForm_Main.HistoryBack;
VAR
  i : integer;
BEGIN
  IF HistoryIndex > 0 then
    Dec(HistoryIndex);
  IF HistoryIndex >= 0 then
    BEGIN
      WITH PHistory[HistoryIndex]^ DO
        BEGIN
          Reverse     := H_Reverse;
          DisplayUnit := H_DisplayUnit;
          FOR i := 0 TO CheckListBox_Units.Count-1 DO
            CheckListBox_Units.State[i] := H_State[i];
          BuildGraphFromUnit(DisplayUnit);
        END;
      ShowGraph;
      ActivateButtons;
    END;
END; {HistoryBack}



PROCEDURE TForm_Main.HistoryForward;
BEGIN
  IF HistoryIndex < CMaxHistory then
    IF PHistory[HistoryIndex+1]^.H_InUse THEN
      BEGIN
        Inc(HistoryIndex, 2);
        HistoryBack;
      END;
END; {HistoryForward}



PROCEDURE TForm_Main.HistoryAdd;
VAR
  i : integer;
  P : TPTHistory;
BEGIN
  IF HistoryIndex >= CMaxHistory
    THEN BEGIN
      P := PHistory[0];
      FOR i := 0 TO CMaxHistory-1 DO
        PHistory[i] := PHistory[i+1];
      PHistory[CMaxHistory] := P;
    END
    ELSE Inc(HistoryIndex);

  WITH PHistory[HistoryIndex]^ DO
    BEGIN
      H_InUse       := true;
      H_Reverse     := Reverse;
      H_DisplayUnit := DisplayUnit;
      Setlength(H_State, CheckListBox_Units.Count);
      FOR i := 0 TO CheckListBox_Units.Count-1 DO
        H_State[i] := CheckListBox_Units.State[i];
    END;

  FOR i := HistoryIndex+1 TO CMaxHistory DO
    PHistory[i]^.H_InUse := false;

  SpeedButton_Previous.Enabled := (HistoryIndex >= 0);
  SpeedButton_Next.Enabled  := false;
  Undo1.Enabled := SpeedButton_Previous.Enabled;
  Redo1.Enabled := SpeedButton_Next.Enabled;
END; {HistoryAdd}


procedure TForm_Main.SpeedButton_PreviousClick(Sender: TObject);
begin
  HistoryBack;
end;

procedure TForm_Main.SpeedButton_NextClick(Sender: TObject);
begin
  HistoryForward;
end;


procedure TForm_Main.About1Click(Sender: TObject);
begin
  ExtraString := Dot.GetDotVersion;
  AboutBox.showModal;
end;

procedure TForm_Main.SpeedButton6Click(Sender: TObject);
begin
  Form_Options := TForm_Options.Create(nil);
  Form_Options.Edit_DotPath.Text := Dot.DotPath;
  Form_Options.CheckBox1.Checked := fHighlightMU;
  IF Form_Options.ShowModal = mrOK
    then begin
      Dot.DotPath := Form_Options.Edit_DotPath.Text;
      fHighlightMU:= Form_Options.CheckBox1.Checked;
      SaveStatus;      
    end;
  Form_Options.free;
end;

procedure TForm_Main.ComboBox_CompilerChange(Sender: TObject);
begin
  CASE ComboBox_Compiler.ItemIndex OF
    0 : Label_CompilerRelatedDirectives.Caption := 'VER70';
    1 : Label_CompilerRelatedDirectives.Caption := 'VER80';
    2 : Label_CompilerRelatedDirectives.Caption := 'VER90,WIN32,MSWINDOWS,CPU386';
    3 : Label_CompilerRelatedDirectives.Caption := 'VER100,WIN32,MSWINDOWS,CPU386';
    4 : Label_CompilerRelatedDirectives.Caption := 'VER120,WIN32,MSWINDOWS,CPU386';
    5 : Label_CompilerRelatedDirectives.Caption := 'VER130,WIN32,MSWINDOWS,CPU386';
    6 : Label_CompilerRelatedDirectives.Caption := 'VER140,WIN32,MSWINDOWS,CPU386';
    7 : Label_CompilerRelatedDirectives.Caption := 'VER150,WIN32,MSWINDOWS,CPU386';
    8 : Label_CompilerRelatedDirectives.Caption := '';    
  END; {case}
  DefaultSwitch := 'A+,B-,D+,E+,F-,G-,I+,K+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,W+,X+,Y+';
end;

procedure TForm_Main.FormShow(Sender: TObject);
begin
  ComboBox_Compiler.OnChange(Sender);
  LoadStatus;
  SpeedButton_ShowProjectData.Visible := false;
  SpeedButton_HideProjectData.Visible := true;
  SpeedButton_ShowProjectData.Left := SpeedButton_HideProjectData.Left;
end;

procedure TForm_Main.Edit_DefinesChange(Sender: TObject);
begin
  Defines := Edit_Defines.Text;
end;

procedure TForm_Main.Edit_DirectivesChange(Sender: TObject);
begin
  Settings := Edit_Directives.Text;
end;

procedure TForm_Main.ComboBox_RecursionChange(Sender: TObject);
begin
   BuildGraphFromUnit(DisplayUnit);
   ShowGraph;
   HistoryAdd;
end;



PROCEDURE TForm_Main.SaveStatus;
VAR
  Ini : TIniFile;
BEGIN
  try
    Ini := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  except
    exit;
  end;

  try
    Ini.WriteString('System', 'DotPath', Dot.DotPath);
    Ini.WriteBool('System', 'HighlightMU', fHighlightMU);
    Ini.WriteBool('System', 'HighlightCR', CheckBox_HighlightCircular.Checked);
    Ini.WriteBool('System', 'HighlightNew', CheckBox_HighlightNew.Checked);

    Ini.WriteString('Input', 'Project', ProjectName);
    Ini.WriteString('Input', 'MainSourceFile', Edit_MainFileName.text);
    Ini.WriteString('Input', 'CondDefines', Edit_Defines.text);
    Ini.WriteString('Input', 'Directives', Edit_Directives.text);
    Ini.WriteString('Input', 'SearchPath', Edit_SearchPath.text);
    Ini.WriteInteger('Input', 'Compiler', ComboBox_Compiler.ItemIndex);
  finally
    Ini.Free;
  end;
END;


PROCEDURE TForm_Main.LoadStatus;
VAR
  Ini : TIniFile;
BEGIN
  try
    Ini := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  except
    exit;
  end;

  try
    Dot.DotPath := Ini.ReadString('System', 'DotPath', Dot.DotPath);
    fHighlightMU:= Ini.ReadBool('System', 'HighlightMU', true);
    CheckBox_HighlightCircular.checked := Ini.ReadBool('System', 'HighlightCR', true);
    CheckBox_HighlightNew.checked := Ini.ReadBool('System', 'HighlightNew', false);
    HighlightNew := CheckBox_HighlightNew.checked;

    Edit_MainFileName.text       := Ini.ReadString('Input', 'MainSourceFile', '');
    Edit_Defines.text            := Ini.ReadString('Input', 'CondDefines', '');
    Edit_Directives.text         := Ini.ReadString('Input', 'Directives', '');
    Edit_SearchPath.text         := Ini.ReadString('Input', 'SearchPath', '');
    ComboBox_Compiler.ItemIndex  := Ini.ReadInteger('Input', 'Compiler', ComboBox_Compiler.ItemIndex);
    ProjectName := Ini.ReadString('Input', 'Project', '');
    IF ProjectName <> '' then
      begin
        IF FileExists(ProjectName)
          then begin
            PostMessage(self.Handle, Msg_LoadFile, 0, 0);
            Caption := ' UnitUsage   [' + ProjectName + ']';
          end
          else Projectname := '';
      end;
  finally
    Ini.Free;
  end;
END;


procedure TForm_Main.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveStatus;
end;

procedure TForm_Main.Includewithchilds1Click(Sender: TObject);
begin
  WITH Sender as TMenuItem DO
    CheckListBox_Units.State[Tag] := cbChecked;
  CheckListBox_UnitsClickCheck(nil);
end;

procedure TForm_Main.Includewithoutchilds1Click(Sender: TObject);
begin
  WITH Sender as TMenuItem DO
    CheckListBox_Units.State[Tag] := cbGrayed;
  CheckListBox_UnitsClickCheck(nil);
end;

procedure TForm_Main.Hide1Click(Sender: TObject);
begin
  WITH Sender as TMenuItem DO
    CheckListBox_Units.State[Tag] := cbUnchecked;
  CheckListBox_UnitsClickCheck(nil);
end;

procedure TForm_Main.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := not(fProcessGraph);
  StopDOT := true;
  IF fProcessGraph then
    begin
      BailOut := true;
      exit;
      //PostMessage(self.Handle, wm_close, 0, 0);
    end;
end;



PROCEDURE TForm_Main.LoadProject(VAR Msg: TMessage);
BEGIN
  OpenProjectEx(ProjectName);
END;



procedure TForm_Main.CheckListBox_UnitsKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
VAR
  Identifier: integer;
begin
  IF HighlightIndex = CheckListBox_Units.ItemIndex then
    exit;
  IF CheckListBox_Units.ItemIndex >= 0 then
    IF not dot.GetNodeIdentifierByCaption(CheckListBox_Units.Items[CheckListBox_Units.ItemIndex], Identifier) then
      Identifier := -1;
  IF Dot.SelNode <> Identifier then
    begin
      Dot.SelNode := Identifier;
      ShowGraph;
    end;
  HighlightIndex := CheckListBox_Units.ItemIndex;
end;

procedure TForm_Main.CheckListBox_UnitsClick(Sender: TObject);
VAR
  w : word;
begin
  CheckListBox_UnitsKeyUp(nil, w, []);
end;

procedure TForm_Main.Newproject1Click(Sender: TObject);
begin
  IF OpenDialog1.execute then
    begin
      Edit_MainFileName.Text := OpenDialog1.FileName;
      ReadDefAndSwitch(ChangeFileExt(OpenDialog1.FileName, '.cfg'), Defines, Settings);
      Edit_Defines.Text := Defines;
      Edit_Directives.Text := Settings;
      ProjectName := '';
      Caption := ' UnitUsage [unnamed]';
      CheckListBox_Units.Clear;
      DOT.Clear;
      ShowGraph;
      HistoryAdd;
    end;
end;

procedure TForm_Main.Help2Click(Sender: TObject);
begin
  MessageDlg('Sorry! Not yet implemented.', mtInformation, [mbOK], 0);
end;

procedure TForm_Main.Options1Click(Sender: TObject);
begin
  SpeedButton6Click(nil);
end;

procedure TForm_Main.SpeedButton_ShowProjectDataClick(Sender: TObject);
begin
  Panel_ProjectSettings.Visible := true;
  Splitter_Horizontal.Visible := true;
  Memo_Watch.Visible := true;
  SpeedButton_ShowProjectData.Visible := false;
  SpeedButton_HideProjectData.Visible := true;
end;

procedure TForm_Main.SpeedButton_HideProjectDataClick(Sender: TObject);
begin
  Panel_ProjectSettings.Visible := false;
  Memo_Watch.Visible := false;
  Splitter_Horizontal.Visible := false;
  SpeedButton_ShowProjectData.Visible := true;
  SpeedButton_HideProjectData.Visible := false;
end;

procedure TForm_Main.SpeedButton_SearchPathClick(Sender: TObject);
var
  AddPath : string;
begin
  IF SelectDirectory('Add a path to "Search path"', '', AddPath) then
    begin
      Edit_SearchPath.Text := Trim(Edit_SearchPath.Text);
      IF Edit_SearchPath.Text <> '' then
        Edit_SearchPath.Text := Edit_SearchPath.Text + ';';
      Edit_SearchPath.Text := AnsiReplaceText(Edit_SearchPath.Text + AddPath, ';;', ';');
    end;
end;

procedure TForm_Main.CheckListBox_UnitsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  IF ssRight IN Shift THEN
    BEGIN
      RightClickIndex := CheckListBox_Units.ItemAtPos(Point(X, Y), true);
      IF (RightClickIndex >= 0) and (RightClickIndex < CheckListBox_Units.Count) then
        begin
          Open1.Caption              := 'View ' + CheckListBox_Units.Items[RightClickIndex];
          BuildTopDownTree1.Caption  := 'Top-Down tree for ' + CheckListBox_Units.Items[RightClickIndex];
          BuildBottomUptree1.Caption := 'Bottom-Up tree for ' + CheckListBox_Units.Items[RightClickIndex];
        end;
    END;
end;




procedure TForm_Main.DisplaySource(FileName: string);
var
  i             : integer;
  SLIn, SLRTF,
  SLOut1, SLOut2: TSourceList;
  _FileName,
  _Defines,
  _Settings   : string;
  ErrMsg      : string;
  TempFileName,
  TempPath    : shortstring;
begin
  IF FileName = '' then
    exit;
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;

  _Defines := Label_CompilerRelatedDirectives.Caption;
  if Trim(Edit_Defines.Text) <> '' then
    _Defines := _Defines + ','+Edit_Defines.Text;
  _Settings := DefaultSwitch;
  IF Trim(Edit_Directives.Text) <> '' then
    _Settings := _Settings + ',' + Edit_Directives.Text;
  SLIn   := TSourceList.Create;
  SLOut1 := TSourceList.Create;
  SLOut2 := TSourceList.Create;
  SLRTF  := TSourceList.Create;
  _FileName := FileName;
  FileName := FileSearch(ExtractFileName(FileName)+'.pas', SearchPath);
  IF FileName = '' then
    FileName := FileSearch(ExtractFileName(_FileName)+'.dpr', SearchPath);

  IF FileName <> '' then
    begin
      SLIn.Clear;
      SLOut1.Clear;
      SLOut2.Clear;
      SLRTF.Clear;
      i := RemoveDeadCode(FileName, SLIn, SLOut1, SLRTF, nil, [PA_DelDirectives, PA_BuildRTF], SearchPath, _Defines, _Settings, ErrMsg);
      GetTempPath(255, @TempPath[1]);
      TempPath[0] := #255;
      TempPath[0] := char(Pos(#0, TempPath)-1);
      GetTempFileName(@TempPath[1], 'UU_', 0, @TempFileName[1]);
      TempFileName[0] := #255;
      TempFileName[0] := char(Pos(#0, TempFileName)-1);
      TAnnotatedStringlist(SLRTF[0]).SaveToFile(TempFileName);
      Form_Viewer.LoadFromTempFile(FileName, TempFileName);
      Form_Viewer.ShowModal;
      deleteFile(TempFileName);
    end;
  SLOut2.Clear;
  SLOut1.Clear;
  SLIn.Clear;
  SLOut2.Free;
  SLOut1.Free;
  SLIn.Free;
end;



procedure TForm_Main.View2Click(Sender: TObject);
begin
  DisplaySource(MouseOverUnit);
end;



procedure TForm_Main.Open1Click(Sender: TObject);
begin
  IF (RightClickIndex >= 0) and (RightClickIndex < CheckListBox_Units.Count) then
    DisplaySource(CheckListBox_Units.Items[RightClickIndex]);
end;





procedure TForm_Main.BuildTopDownTree1Click(Sender: TObject);
begin
  IF (RightClickIndex >= 0) and (RightClickIndex < CheckListBox_Units.Count) then
    begin
      DisplayUnit := CheckListBox_Units.Items[RightClickIndex];
      SpeedButton_TopDownClick(nil);
    end;
end;

procedure TForm_Main.BuildBottomUptree1Click(Sender: TObject);
begin
  IF (RightClickIndex >= 0) and (RightClickIndex < CheckListBox_Units.Count) then
    begin
      DisplayUnit := CheckListBox_Units.Items[RightClickIndex];
      SpeedButton_BottomUpClick(nil);
    end;
end;



procedure TForm_Main.CheckBox_AutoRefreshClick(Sender: TObject);
begin
  Speedbutton_Refresh.Enabled := not CheckBox_AutoRefresh.Checked;
end;

procedure TForm_Main.SpeedButton_RefreshClick(Sender: TObject);
begin
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
  HistoryAdd;
end;


procedure TForm_Main.ExecuteWaitEvent(const ProcessInfo: TProcessInformation;
                                      const StartedAt: integer;
                                      var ATerminate: Boolean);
var
  i : integer;
begin
  ATerminate := StopDOT;
  StopDOT := false;
  IF Abs(LastDOTTick - StartedAt) < 100 then
    exit;
  LastDOTTick := TimeGetTime;
  i := (LastDOTTick - StartedAt) div 1000;
  Statusbar1.Panels[0].Text := 'Calling DOT  [' + IntToStr(i div 60) + ':' + AnsiRightStr('0'+IntToStr(i mod 60), 2) + ']';
  Statusbar1.refresh;
  Application.ProcessMessages;
end;


procedure TForm_Main.OnMsgShowDOT(VAR Msg: TMessage);
begin
  ShowGraph;
end;



procedure TForm_Main.CheckBox_HighlightCircularClick(Sender: TObject);
begin
  DOT.MarkReversedArrow := CheckBox_HighLightCircular.Checked;
  ShowGraph;
end;


procedure TForm_Main.CheckBox_HighlightNewClick(Sender: TObject);
begin
  HighlightNew := CheckBox_HighlightNew.checked;
  BuildGraphFromUnit(DisplayUnit);
  ShowGraph;
end;

end.


